Unit AFP5R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP5R(var A :Array of Real; N :Integer; M :Integer;
                var D1 :Array of Real; var D2 :Array of Real);

implementation

procedure AFP5R(var A :Array of Real; N :Integer; M :Integer;
                var D1 :Array of Real; var D2 :Array of Real);
var
I,J,B,C :Integer;
E,F,G,H,BP,BR :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30;
begin
for B:=1 to N do
 begin
  if ( B <> M ) 
   then goto _1;
  D1[B-1] := A[(B-1)+(B-1)*N];
  A[(B-1)+(B-1)*N] := 0.0;
  goto _30;
_1:
  for J:=B to M do
   begin
    D1[J-1] := A[(B-1)+(J-1)*N];
_2:
   end;
  E := 0.0;
  for J:=B to M do
   begin
    F := Abs(D1[J-1]);
    if ( E >= F ) 
     then goto _3;
    E := F;
_3:
   end;
  if ( E <> 0.0 ) 
   then goto _4;
  C := B+1;
  goto _15;
_4:
  F := 1.0/E;
  H := 0.0;
  for J:=B to M do
   begin
    H := H+D1[J-1]*F*D1[J-1]*F;
_5:
   end;
  E := Sqrt(H)*E;
  F := 1.0/E;
  for J:=B to M do
   begin
    D1[J-1] := D1[J-1]*F;
_6:
   end;
  if ( D1[B-1] <> 0.0 ) 
   then goto _7;
  D1[B-1] := 1.0;
  G := -E;
  goto _9;
_7:
  G := Sign(1.0,D1[B-1]);
  F := 1.0+Abs(D1[B-1]);
  D1[B-1] := G*F;
  F := 1.0/Sqrt(F);
  for J:=B to M do
   begin
    D1[J-1] := D1[J-1]*F;
_8:
   end;
  G := -E*G;
_9:
  for J:=B to M do
   begin
    A[(B-1)+(J-1)*N] := D1[J-1];
_10:
   end;
  if ( B <> N ) 
   then goto _11;
  D1[B-1] := G;
  goto _30;
_11:
  C := B+1;
  for I:=C to N do
   begin
    BP := 0.0;
    for J:=B to M do
     begin
      BP := BP+A[(I-1)+(J-1)*N]*D1[J-1];
_12:
     end;
    for J:=B to M do
     begin
      A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]-BP*D1[J-1];
_13:
     end;
_14:
   end;
  D1[B-1] := G;
_15:
  if ( C <> N ) 
   then goto _16;
  D2[B-1] := A[(C-1)+(B-1)*N];
  A[(C-1)+(B-1)*N] := 0.0;
  goto _29;
_16:
  for I:=C to N do
   begin
    D2[I-1] := A[(I-1)+(B-1)*N];
_17:
   end;
  E := 0.0;
  for I:=C to N do
   begin
    F := Abs(D2[I-1]);
    if ( E >= F ) 
     then goto _18;
    E := F;
_18:
   end;
  if ( E <> 0.0 ) 
   then goto _19;
  D2[B-1] := 0.0;
  goto _29;
_19:
  F := 1.0/E;
  H := 0.0;
  for I:=C to N do
   begin
    H := H+D2[I-1]*F*D2[I-1]*F;
_20:
   end;
  E := Sqrt(H)*E;
  F := 1.0/E;
  for I:=C to N do
   begin
    D2[I-1] := D2[I-1]*F;
_21:
   end;
  if ( D2[C-1] <> 0.0 ) 
   then goto _22;
  D2[C-1] := 1.0;
  G := -E;
  goto _24;
_22:
  G := Sign(1.0,D2[C-1]);
  F := 1.0+Abs(D2[C-1]);
  D2[C-1] := G*F;
  F := 1.0/Sqrt(F);
  for I:=C to N do
   begin
    D2[I-1] := D2[I-1]*F;
_23:
   end;
  G := -E*G;
_24:
  for I:=C to N do
   begin
    A[(I-1)+(B-1)*N] := D2[I-1];
_25:
   end;
  for J:=C to M do
   begin
    BR := 0.0;
    for I:=C to N do
     begin
      BR := BR+A[(I-1)+(J-1)*N]*D2[I-1];
_26:
     end;
    for I:=C to N do
     begin
      A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]-BR*D2[I-1];
_27:
     end;
_28:
   end;
  D2[B-1] := G;
_29:
 end;
_30:
end;

end.
